package com.tidecloud.dataacceptance.bean;

import org.apache.commons.pool2.impl.GenericObjectPoolConfig;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.cache.annotation.CachingConfigurerSupport;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import redis.clients.jedis.JedisPool;

/**   
 * @author: chudk 
 * @date:   2017年9月11日 下午1:29:12   
 */
@Configuration
public class RedisConfig extends CachingConfigurerSupport{
    
    @Value("${spring.redis.host}")
    private String host;
    
    @Value("${spring.redis.port}")
    private Integer port;
    
    @Value("${spring.redis.timeout}")
    private Integer timeOut;
    
    @Value("${spring.redis.password}")
    private String password;
    
    @Bean
    public JedisPool redisPoolFactory() {
        GenericObjectPoolConfig config = new GenericObjectPoolConfig();
        JedisPool jedisPool = new JedisPool(config, host, port, timeOut, password);
        return jedisPool;
    }
}
