package com.tidecloud.dataacceptance.service;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import io.netty.buffer.ByteBuf;
import io.netty.channel.Channel;
import io.netty.channel.ChannelHandlerContext;

public abstract class StringAcceptanceHandlerAdapter extends AcceptanceInboundHandlerAdapter {
	private static final Logger logger = LoggerFactory.getLogger(AcceptanceInboundHandlerAdapter.class);
	
	@Override
	public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
		super.channelRead(ctx, msg);
		ByteBuf byteBuf = (ByteBuf) msg;
		String str = byteBufferToString(byteBuf.nioBuffer());
		logger.info("接入数据：{}", str);
		try {
			handle(str,ctx.channel());
		} catch (Exception e) {
			logger.error(e.getMessage());
		} finally {
			byteBuf.release();
		}
		ctx.flush();
	}

	abstract protected void handle(String in, Channel channel) throws Exception;

}
