package com.tidecloud.dataacceptance.service.impl;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import com.tidecloud.dataacceptance.rfid.ReaderDataPackageParser;
import com.tidecloud.dataacceptance.rfid.ReaderDataPackageProcess;
import com.tidecloud.dataacceptance.rfid.module.interaction.DataPackageParser;
import com.tidecloud.dataacceptance.rfid.module.interaction.DataPackageProcess;
import com.tidecloud.dataacceptance.rfid.rxobserver.RXObserver;
import com.tidecloud.dataacceptance.service.HexBinaryAcceptanceHandlerAdapter;
import com.tidecloud.dataacceptance.util.FileUtils;

import io.netty.buffer.ByteBuf;
import io.netty.channel.Channel;
import io.netty.channel.ChannelHandler;

/**
 * @author ryan
 */
@Component
@Scope("prototype")
@ChannelHandler.Sharable
public class VorgeaUR0401ServerHandler extends HexBinaryAcceptanceHandlerAdapter {

	private static final Logger logger = LoggerFactory.getLogger(VorgeaUR0401ServerHandler.class);
	

	DataPackageParser mPackageParser = new ReaderDataPackageParser();
	DataPackageProcess mPackageProcess = new ReaderDataPackageProcess();
	
	private RXObserver mObserver = new RXObserver() ;
	DateFormat fmt = new SimpleDateFormat("yyyyMMddHHmmss");

	

	@Override
	protected void handle(ByteBuf in, Channel channel) throws Exception {
		ByteBuf byteBuf = (ByteBuf) in;
		int len = byteBuf.readableBytes();

		byte[] btAryReceiveData = new byte[len];

		byteBuf.getBytes(0, btAryReceiveData);

		mPackageProcess.addObserver(mObserver);
		
		mPackageParser.runReceiveDataCallback(btAryReceiveData, mPackageProcess);
		// String strEPC = mObserver.ge
		
		// manageChannel(ctx.channel(), phone);
		String epc = mObserver.getStrEPC();
		String deviceId = mObserver.getDeviceId();
		String storageStr = deviceId+";"+epc+";"+fmt.format(new Date());
		FileUtils.dataStorage(storageStr.getBytes(),dataPath,prefixName);
		
	}


}
