package com.tidecloud.dataacceptance.web;

import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.smartsanitation.common.response.ResultWrapper;
import com.tidecloud.dataacceptance.response.CommandCopy;
import com.tidecloud.dataacceptance.service.impl.WatchServerHandler;

import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.Channel;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;

/**   
 * @author: chudk 
 * @date:   2017年9月28日 上午11:14:50   
 */
//@RestController
public class WatchController {
    
    private static final Logger logger = LoggerFactory.getLogger(WatchController.class);
    
    @RequestMapping(value = "setting/uploadtime", method = RequestMethod.GET)
    public ResultWrapper<CommandCopy> sendCommand2Device(@RequestParam String commandStr, 
                                                         @RequestParam String socketId){
        Map<String, Channel> channelMap = WatchServerHandler.manageChannelMap;
        if (channelMap.isEmpty()) {
            return ResultWrapper.ok(new CommandCopy());
        }
        Channel channel = channelMap.get(socketId);
        try {
            logger.info("start write command to device the address [{}]", channel.remoteAddress());
            ByteBuf buffer = Unpooled.buffer(commandStr.length());
            buffer.writeBytes(commandStr.getBytes());
            channel.writeAndFlush(buffer);
            logger.info("end write command to device the address [{}]", channel.remoteAddress());
        } catch (Exception e) {
            logger.error(e.getLocalizedMessage());
        }
        return null;
    }
    
}
