package com.tidecloud.dataacceptance;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.xml.bind.DatatypeConverter;

import io.netty.bootstrap.Bootstrap;
import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelInitializer;
import io.netty.channel.ChannelOption;
import io.netty.channel.EventLoopGroup;
import io.netty.channel.nio.NioEventLoopGroup;
import io.netty.channel.socket.SocketChannel;
import io.netty.channel.socket.nio.NioSocketChannel;

public class HelloClient {

	public void connect(String host, int port) throws Exception {  
        
        EventLoopGroup workerGroup = new NioEventLoopGroup();  
        try {  
            Bootstrap b = new Bootstrap();  
            b.group(workerGroup).channel(NioSocketChannel.class).option(ChannelOption.SO_KEEPALIVE, true)  
                    .handler(new ChannelInitializer<SocketChannel>() {  
                        @Override  
                        public void initChannel(SocketChannel ch) throws Exception {  
                            ch.pipeline().addLast(new HelloClientIntHandler());  
                        }  
                    });  
  
            // Start the client.  
            ChannelFuture f = b.connect(host, port).sync();  
           
         //  f.channel().close();
            // Wait until the connection is closed.  
         //  f.channel().closeFuture().sync();  
        } finally {  
            workerGroup.shutdownGracefully();  
        }  
    }  
  
    public static void main(String[] args) throws Exception {  
    	
    	
        HelloClient client = new HelloClient();  
        
      
        ExecutorService singleThreadPool = Executors.newFixedThreadPool(20);
        
        int i =0 ;
        while (i++<1) 
        {
        	
        	singleThreadPool.execute(()->{
        		 
                try {
        				client.connect("localhost", 7011);
        				Thread.sleep(2000);
        			} catch (Exception e) {
        				// TODO Auto-generated catch block
        				e.printStackTrace();
        			}
       		}); 
        	
        }
        
        System.out.println("end");
    }  
}
